--------------------------
-- Frame
--------------------------

local EventFrame = CreateFrame("Frame", "EventFrame", UIParent)

--------------------------
-- Event
--------------------------

EventFrame:SetScript("OnEvent", function(self, event, ...)
	if type(self[event]) == "function" then
		return self[event](self, event, ...)
	end
end)

--------------------------
-- Command
--------------------------

SLASH_HIDEMINIMAP1, SLASH_HIDEMINIMAP2 = '/hm', '/hideminimap';

--------------------------
-- Stuff To Hide
--------------------------

local Hide = {
			"Minimap","MinimapZoneTextButton","MinimapCluster",
			}
			
--------------------------
-- Function
--------------------------			

local function handler(msg, editbox)
 if msg == 'on' then
  	hmon = true
	for index,value in pairs(Hide) do
		_G[value]:SetAlpha(0)
		_G[value]:Hide()
	end
 elseif msg == 'off' then
  	hmon = false
	for index,value in pairs(Hide) do
		_G[value]:SetAlpha(100)
		_G[value]:Show()
	end
 elseif msg == 'auto' then
	hmauto = true
	hmon = false
 end
end
SlashCmdList["HIDEMINIMAP"] = handler;

EventFrame.ADDON_LOADED = function(self, event, addon)
	
	if (hmon) then
			-- Nothing, the minimap is hidden
			--StaticPopup_Show("HMON")
			-- Hide the minimap
			for index,value in pairs(Hide) do
				_G[value]:SetAlpha(0)
				_G[value]:Hide()
			end
	else
			--StaticPopup_Show("HMOFF")
	end
	
	self:UnregisterEvent(event)
end

EventFrame.PLAYER_REGEN_DISABLED = function(self, event, addon)

	if (hmauto) then
			for index,value in pairs(Hide) do
				_G[value]:SetAlpha(0)
				_G[value]:Hide()
			end
	end
	
	--self:UnregisterEvent(event)
end

EventFrame.PLAYER_REGEN_ENABLED = function(self, event, addon)

	if (hmauto) then
			for index,value in pairs(Hide) do
				_G[value]:SetAlpha(100)
				_G[value]:Show()
			end
	end
	
	--self:UnregisterEvent(event)
end

--------------------------
-- Popup Test
--------------------------

StaticPopupDialogs["HMON"] = {
	text = "La variable est TRUE.",
        button1 = "OK",
        timeout = 0,
        whileDead = 1,
}

StaticPopupDialogs["HMOFF"] = {
	text = "La variable est FALSE.",
        button1 = "OK",
        timeout = 0,
        whileDead = 1,
}

--------------------------
-- Registered Event
--------------------------

EventFrame:RegisterEvent("ADDON_LOADED")
EventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
